#!/usr/bin/env node
"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var dic_1 = require("../util/dic");
var config = require(dic_1.ROOT_PACKAGE_PATH('package.json'));
var util_1 = require("../util");
process.argv[2] === 'dev' ? util_1.setNodeEnv('development') : util_1.setNodeEnv('production');
config.name == '@nutui/nutui-jdl' ? util_1.setVersion('jdl') : util_1.setVersion('2');
var commander_1 = __importDefault(require("commander"));
var dev_1 = require("../commands/dev");
var build_1 = require("../commands/build");
var build_site_1 = require("../commands/build-site");
var clean_1 = require("../commands/clean");
var createComponent_1 = require("../commands/createComponent");
var commitLint_1 = require("../commands/commitLint");
var test_1 = require("../commands/test");
var npmPublish_1 = require("../commands/npmPublish");
var config_cli = require(dic_1.ROOT_CLI_PATH('package.json'));
commander_1.default.version("@minixui/cli " + config_cli.version, '-v', '--version');
commander_1.default.command('dev').description('本地调试运行官网和Demo示例').action(dev_1.dev);
commander_1.default.command('build').description('构建完整版ui和各个组件可发布到npm的静态资源包').action(build_1.build);
commander_1.default.command('build-site').description('构建官网和Demo示例，进行官网发布').action(build_site_1.buildSite);
commander_1.default.command('clean').description('清空打包目录').action(clean_1.clean);
commander_1.default.command('add').description('新增组件使用该命令').action(createComponent_1.createComponent);
commander_1.default.command('commit-lint').description('获取校验commit message 的配置文件').action(commitLint_1.commitLint);
commander_1.default.command('test').description('运行单元测试').action(test_1.test);
commander_1.default.command('release').description('发布版本...待开发').action(npmPublish_1.release);
commander_1.default.parse(process.argv);
//# sourceMappingURL=index.js.map