"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.prodConfig = void 0;
var webpack_merge_1 = __importDefault(require("webpack-merge"));
var dev_config_1 = require("./dev.config");
var dic_1 = require("../util/dic");
var copy_webpack_plugin_1 = __importDefault(require("copy-webpack-plugin"));
var optimize_css_assets_webpack_plugin_1 = __importDefault(require("optimize-css-assets-webpack-plugin"));
exports.prodConfig = webpack_merge_1.default(dev_config_1.devConfig, {
    mode: 'production',
    output: {
        path: dic_1.ROOT_PACKAGE_PATH('dist/'),
        filename: 'js/[name].[hash].bundle.min.js',
        chunkFilename: 'js/[name].[chunkhash].chunk.min.js'
    },
    optimization: {
        minimize: true,
        splitChunks: {
            automaticNameDelimiter: '_',
        }
    },
    plugins: [
        new optimize_css_assets_webpack_plugin_1.default(),
        new copy_webpack_plugin_1.default([
            {
                from: dic_1.ROOT_CLI_PATH('site/demo/asset/img/favicon.ico'),
                to: dic_1.ROOT_PACKAGE_PATH('dist/')
            }
        ]),
        new copy_webpack_plugin_1.default([
            {
                from: dic_1.ROOT_CLI_PATH('site/demo/asset/img/pwa_logo.png'),
                to: dic_1.ROOT_PACKAGE_PATH('dist/img/')
            }
        ]),
    ]
});
//# sourceMappingURL=prod.config.js.map