"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var dic_1 = require("../util/dic");
var package_config_1 = require("./package.config");
var webpack_merge_1 = __importDefault(require("webpack-merge"));
module.exports = webpack_merge_1.default(package_config_1.packageConfig(false), {
    module: {
        rules: [
            {
                test: /\.(js|ts)/,
                use: {
                    loader: 'istanbul-instrumenter-loader',
                    options: { esModules: true },
                },
                include: [dic_1.ROOT_PACKAGE_PATH('src/packages')],
            },
            {
                test: /\.css$/,
                use: ['style-loader', 'css-loader'],
            },
            {
                test: /\.scss$/,
                use: [
                    'style-loader',
                    'css-loader',
                    {
                        loader: 'sass-loader',
                        options: {
                            prependData: "@import \"@/styles/index.scss\"; ",
                        },
                    },
                ],
            },
        ],
    },
    devtool: 'inline-cheap-module-source-map',
    externals: [require('webpack-node-externals')()],
});
//# sourceMappingURL=test.config.js.map